
/*============================================================================================================
 *
 * (#)Downloader.java
 * created      2002/12/08
 * __________________________________________________________________________________________________________
 * For documentation:                                                                                        *
 *                                                                                                           *
 * http://developer.java.sun.com/developer/techDocs/SearchData/qa/API_documentation_for_sun.net.html         *
 * http://www.artima.com/java/answers/Jan2001/messages/394.html                                              *
 * http://www.ibiblio.org/javafaq/books/secrets/secretsexamples/                                             *
 * http://sunsite.iisc.ernet.in/virlib/java/vj_unleash/ch17.htm#TheTTFONTSIZEsunnetFONTTTFONTSIZEPackageFONT *
 * http://lists.dalsemi.com/maillists/tini/2000-August/007169.html                                           *
 * http://finj.sourceforge.net/                                                                              *
 * http://www.jguru.com/faq/view.jsp?EID=17357                                                               *
 * http://www.ms.mff.cuni.cz/~tjir5186/java/FtpAsciiText.java.iso-8859-1                                     *
 * http://exzilla.hypermart.net/memberArticles/uKitti/FTPFile.java.txt                                       *
 * http://www.geocrawler.com/archives/3/196/2000/8/50/4261223/                                               *
 * __________________________________________________________________________________________________________*
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.

 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.

 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 *============================================================================================================
 */

package com.miami.romeo.internet;

//****** imports
import java.awt.*;
import java.awt.event.*;
import java.util.*;
import java.io.*;
import java.net.*;
import java.text.*;

import javax.swing.*;
import javax.swing.border.*;
import javax.swing.event.*;

import sun.net.ftp.*;
import sun.net.*;

import com.miami.romeo.config.*;

/**
 * Downloader.<br>
 * This class downloads files from the internet.
 *
 * @author       $author: Stefano Bolli
 * @version      $Revision: 1.1.1.1 $Date: 2003/10/18 03:17:52 $
 */
public class Downloader extends JPanel {
  //****** Class needed by Downloader.java
  Utils utils = new Utils();

  // File name
  String fileName;
  // Where will Downloader save the file?
  String destination;
  // Which server will be used?
  String server;

  // Images to create an animation
  ImageIcon[] imgs = {new ImageIcon(getClass().getResource(
                                            "/images/animation/Download0.png")),
                      new ImageIcon(getClass().getResource(
		                            "/images/animation/Download1.png")),
                      new ImageIcon(getClass().getResource(
		                            "/images/animation/Download2.png")),
                      new ImageIcon(getClass().getResource(
		                            "/images/animation/Download3.png")),
                      new ImageIcon(getClass().getResource(
		                            "/images/animation/Download4.png")),
                      new ImageIcon(getClass().getResource(
		                            "/images/animation/Download5.png")),
                      new ImageIcon(getClass().getResource(
		                            "/images/animation/Download6.png")),
                      new ImageIcon(getClass().getResource(
		                            "/images/animation/Download7.png")),
                      new ImageIcon(getClass().getResource(
		                            "/images/animation/Download8.png")),
                      new ImageIcon(getClass().getResource(
		                            "/images/animation/Download9.png")),
                      new ImageIcon(getClass().getResource(
		                           "/images/animation/Download10.png")),
                      new ImageIcon(getClass().getResource(
		                           "/images/animation/Download11.png")),
                      new ImageIcon(getClass().getResource(
		                           "/images/animation/Download12.png")),
                      new ImageIcon(getClass().getResource(
		                           "/images/animation/Download13.png")),
                      new ImageIcon(getClass().getResource(
		                          "/images/animation/Download14.png"))};

  // Delay for timers
  public final static int ONE_SECOND = 1000;

  int img = 0;

  // Elapsed time from the download beginning
  String elapsedTime;
  // Last date
  String lastDate;
  // Time left
  String timeLeft;
  // Hours, minutes, seconds...
  long d, h, m, s;

  // Gregorian calendars to know elapsed time from the beginning
  protected GregorianCalendar currentTime = null;
  protected GregorianCalendar startTime   = null;

  // Values to know time to the end
  int FILE_SIZE, KB_TO_TRANSFER, TRANSFER_RATE, TIME_LEFT;
  int PREVIOUS_TRANSFER = 0;

  // Timers
  private javax.swing.Timer timer;
  private javax.swing.Timer timer2;
  private javax.swing.Timer timer3;

  // Labels
  JLabel animationLabel      = null;
  JLabel statusLabel         = null;
  JLabel statusLabel2        = null;
  JLabel timeLabel           = null;
  JLabel timeLabel2          = null;
  JLabel timeLeftLabel       = null;
  JLabel timeLeftLabel2      = null;
  JLabel downloadInLabel     = null;
  JLabel downloadInLabel2    = null;
  JLabel transferRateLabel   = null;
  JLabel transferRateLabel2  = null;
  JLabel transferedKbLabel   = null;
  JLabel transferedKbLabel2  = null;

  // Progress Bar
  JProgressBar progressBar = null;

  // Buttons
  JButton get   = null;
  JButton close = null;

  // The socket input stream
  private InputStream is       = null;
  // The socket output stream
  private FileOutputStream out = null;

  // ftp stuff
  String ftpUrl, user, password, ftpServer, urlPath;
  int port;
  protected FtpClient client;
  protected String localFile;
  protected String hostFile;

  // Action & window listeners
  Download download = new Download();
  Exit exit         = new Exit();

  // Used cause Downloader is an application.
  private static JFrame frame = null;

  /**
   * Constructor
   *
   * @param server      The server address
   * @param destination The path where to save files in
   * @param fileName    The file name to download
   */
  public Downloader(String server, String destination,
                    String fileName) {
    this.server = server;
    this.destination = destination;
    this.fileName = fileName;

    frame = createFrame();

    setLayout(null);

    initializeDownloader();

    showDownloader();
  }

  /**
   * This method initializes all graphic components.
   */
  public void initializeDownloader() {
    animationLabel = new JLabel(imgs[img]);
    animationLabel.setBounds(10, 10, 272, 60);
    add(animationLabel);

    statusLabel = new JLabel(utils.getString("Downloader.label_status"));
    statusLabel.setBounds(10, 85, 370, 15);
    add(statusLabel);

    statusLabel2 = new JLabel(utils.getString("Downloader.label_ready"));
    statusLabel2.setBounds(10, 105, 370, 15);
    add(statusLabel2);

    progressBar = new JProgressBar();
    progressBar.setBounds(10, 128, 370, 15);
    progressBar.setMinimum(0);
    progressBar.setStringPainted(true);
    add(progressBar);

    timeLabel = new JLabel(utils.getString("Downloader.label_time_elapsed"));
    timeLabel.setBounds(10, 150, 185, 15);
    add(timeLabel);

    timeLabel2 = new JLabel();
    timeLabel2.setBounds(185, 150, 185, 15);
    add(timeLabel2);

    timeLeftLabel = new JLabel(utils.getString("Downloader.label_time_left"));
    timeLeftLabel.setBounds(10, 170, 185, 15);
    add(timeLeftLabel);

    timeLeftLabel2 = new JLabel();
    timeLeftLabel2.setBounds(185, 170, 185, 15);
    add(timeLeftLabel2);

    downloadInLabel = new JLabel(utils.getString(
                                              "Downloader.label_download_in"));
    downloadInLabel.setBounds(10, 190, 185, 15);
    add(downloadInLabel);

    downloadInLabel2 = new JLabel();
    downloadInLabel2.setBounds(185, 190, 185, 15);
    add(downloadInLabel2);

    transferRateLabel = new JLabel(utils.getString(
                                             "Downloader.label_transfer_rate"));
    transferRateLabel.setBounds(10, 210, 185, 15);
    add(transferRateLabel);

    transferRateLabel2 = new JLabel();
    transferRateLabel2.setBounds(185, 210, 185, 15);
    add(transferRateLabel2);

    transferedKbLabel = new JLabel(utils.getString("Downloader.label_kb"));
    transferedKbLabel.setBounds(10, 230, 185, 15);
    add(transferedKbLabel);

    transferedKbLabel2 = new JLabel();
    transferedKbLabel2.setBounds(185, 230, 185, 15);
    add(transferedKbLabel2);

    get = new JButton(utils.getString("Downloader.button_download"));
    get.setBounds(160, 265, 105, 35);
    get.setIcon(utils.createImageIcon24x24("Download.png"));
    get.addActionListener(download);
    add(get);

    close = new JButton(utils.getString("Settings.Cancel"));
    close.setBounds(275, 265, 105, 35);
    close.setIcon(utils.createImageIcon24x24("Cancel.png"));
    close.addActionListener(exit);
    add(close);

    //Create a first timer to start the animation.
    timer = new javax.swing.Timer(500, new ActionListener() {
      public void actionPerformed(ActionEvent evt) {
        animationLabel.setIcon(imgs[img]);
        img++;
        if (img == 15) {
          img = 0;
          timer.restart();
        }
      }
    });

    //Create a second timer to know elapsed time.
    timer2 = new javax.swing.Timer(ONE_SECOND, new ActionListener() {
      public void actionPerformed(ActionEvent evt) {
        // Get current time
	currentTime = new GregorianCalendar();

        Date d1 = currentTime.getTime();
        Date d2 = startTime.getTime();
        long l1 = d1.getTime();
        long l2 = d2.getTime();
        long difference = l1 - l2;

        // Days, hours, minutes, seconds elapsed
	s = difference / 1000;
        d = s / (3600 * 24);
        s = s - (d * 86400);
        h = s / 3600;
        s = s - (h * 3600);
        m = s / 60;
        s = s - (m * 60);
	
	String zeroH = "";
	String zeroM = "";
	String zeroS = "";

	if (h < 10)
	  zeroH = "0";
	  
	if (m < 10)
	  zeroM = "0";

	if (s < 10)
	  zeroS = "0";

	elapsedTime = zeroH + h + ":" + zeroM + m + ":" + zeroS + s;

        message(timeLabel2, elapsedTime);

        lastDate = elapsedTime;
        currentTime = null;
      }
    });

    //Create a third timer to know time left.
    timer3 = new javax.swing.Timer(ONE_SECOND, new ActionListener() {
      public void actionPerformed(ActionEvent evt) {
	if (progressBar.getMaximum() > 0) {
	  // Get transfered kilobytes until now
	  FILE_SIZE = progressBar.getValue();

	  // Get kilobytes to transfer
	  KB_TO_TRANSFER = progressBar.getMaximum() - FILE_SIZE;

	  // Get transfer rate per second...
	  // Still in progress, I'd like to have a long value
	  // not an int but I have not time now :(
	  TRANSFER_RATE = FILE_SIZE - PREVIOUS_TRANSFER;

	  message(transferRateLabel2, (TRANSFER_RATE / 1024) + " KB/S");

	  if (TRANSFER_RATE != 0)
	    TIME_LEFT = KB_TO_TRANSFER / TRANSFER_RATE;
          else
            TIME_LEFT = KB_TO_TRANSFER;

	  //System.out.println("tempo restante: " + TIME_LEFT);

          s = TIME_LEFT;
          d = s / (3600 * 24);
          s = s - (d * 86400);
          h = s / 3600;
          s = s - (h * 3600);
          m = s / 60;
          s = s - (m * 60);

	  String zeroH = "";
	  String zeroM = "";
	  String zeroS = "";

	  // Dirty way to read time left in format hh:mm:ss
	  if (h < 10)
	    zeroH = "0";

	  if (m < 10)
	    zeroM = "0";

	  if (s < 10)
	    zeroS = "0";

	  timeLeft = zeroH + h + ":" + zeroM + m + ":" + zeroS + s;

          message(timeLeftLabel2, timeLeft);

	  // Transfered kb one second ago
	  PREVIOUS_TRANSFER = FILE_SIZE;
        }
      }
    });
  }

  /**
   * This method shows Downloader window.
   */
  public void showDownloader() {
    if(getFrame() != null) {
      // put Downloader in a frame and show it
      JFrame f = getFrame();
      f.setTitle("Romeo Downloader");
      f.getContentPane().add(this, BorderLayout.CENTER);

      // Set size and location.
      f.setSize(400, 340);
      f.setResizable(false);
      Dimension screenDim = Toolkit.getDefaultToolkit().getScreenSize();
      Rectangle frameDim = f.getBounds();
      f.setLocation((screenDim.width - frameDim.width) / 2,
                    (screenDim.height - frameDim.height) / 2);

      getFrame().show();
    }
  }

  /**
   * This method returns the frame instance.
   *
   * @return <code>JFrame</code>
   */
  public JFrame getFrame() {
    return frame;
  }

  /**
   * This method creates a frame for Downloader to reside in.
   */
  public JFrame createFrame() {
    final JFrame frame = new JFrame();

    Image icon = Toolkit.getDefaultToolkit().getImage(
                         getClass().getResource(
			 "/images/icons/16x16/Download_manager.png"));

    frame.setIconImage(icon);

    frame.addWindowListener(exit);
    return frame;
  }

  // *******************************************************
  // ********************   Actions  ***********************
  // *******************************************************

  /**
   * Action listener for 'Download' button
   */
  public class Download implements ActionListener {
    public void actionPerformed(ActionEvent e) {
      // Check if file exists
      File f = new File(destination + fileName);

      if (f.exists()) {
        int result = JOptionPane.showConfirmDialog(null,
                     utils.getString("OptionPane.file_exists_confirmquestion"));

        if(result == JOptionPane.YES_OPTION) {
          f.delete();
          defineProtocolToUse();
        }
        else if(result == JOptionPane.NO_OPTION) {
          JOptionPane.showMessageDialog(null,
	                    utils.getString("Messagebox.file_exists_confirmno"),
                            utils.getString("Messagebox.info_title"),
                            JOptionPane.INFORMATION_MESSAGE);

          frame.setVisible(false);
	  final JFrame frame = null;
        }
      }
      else {
        defineProtocolToUse();
      }
    }
  }

  /**
   * Exit Action
   */
  public class Exit implements ActionListener, WindowListener {
    public void actionPerformed(ActionEvent e) {
      if (is != null && out != null) {
        try {
	  is.close();
	  out.flush();
	  out.close();
	}
	catch (IOException ioe2) {
	  System.err.println(ioe2.getMessage());
	}

	File file = new File(destination + fileName);
        if (file.exists())
	  file.delete();
      }

      disconnect();

      frame.setVisible(false);
      final JFrame frame = null;
    }

    public void windowClosing(WindowEvent e) {
      if (is != null && out != null) {
        try {
	  is.close();
	  out.flush();
	  out.close();
	}
	catch (IOException ioe2) {
	  System.err.println(ioe2.getMessage());
	}

	File file = new File(destination + fileName);
        if (file.exists())
	  file.delete();
      }

      disconnect();

      frame.setVisible(false);
      final JFrame frame = null;
    }

    public void windowOpened(WindowEvent e) {
      /* to handle */
    }

    public void windowClosed(WindowEvent e) {
      /* to handle */
    }

    public void windowIconified(WindowEvent e) {
      /* to handle */
    }

    public void windowDeiconified(WindowEvent e) {
      /* to handle */
    }

    public void windowActivated(WindowEvent e) {
      /* to handle */
    }

    public void windowDeactivated(WindowEvent e) {
      /* to handle */
    }
  }
  
  /**
   * This method defines the protocol (http or ftp) to use
   * and download the file.
   */
  public void defineProtocolToUse() {
    // Define type of protocol to use and download the file
    if (is == null && out == null) {
      // Http protocol
      if (server.startsWith("http://")) {
	get.removeActionListener(download);

        // Use a thread to simulate multi-threading operations
	Thread thread = new Thread() {
          public void run() {
            getHttpFile();
          }
        };

        thread.start();
      }
      // Ftp protocol
      else if (server.startsWith("ftp://")) {
        //****** Parse url
	// Romeo handles these kinds of URL:
	// 1) ftp://ftp.roms.org/dir/
	// 2) ftp://ftp.roms.org:port/dir/
	// 3) ftp://user:password@ftp.roms.org:port/dir/
	// 4) ftp://user:password@ftp.roms.org/dir/

	// It' s possible to specify user name, password, server port,
	// file path

        // Get ftp URL without protocol
	ftpUrl = server.substring(6);
        // Verify if user and password are specified
	int idx_at = ftpUrl.indexOf("@");
        if (idx_at > 0) {
          int idx_p = ftpUrl.indexOf(":");
	  // Get user name
          user = ftpUrl.substring(0, idx_p);
	  // Get password
          password = ftpUrl.substring(idx_p + 1, idx_at);
	    
	  // Get URL after char '@'
          ftpUrl = ftpUrl.substring(idx_at + 1);

	  // Verify if a server port  is specified
          int idx_p1 = ftpUrl.indexOf(":");
          if (idx_p1 > 0) {
            // Verify if a path is specified after ftp URL
	    int idx_slash = ftpUrl.indexOf("/");
            if (idx_slash > 0) {
              // Get ftp URL
	      ftpServer = ftpUrl.substring(0, idx_p1);
              // Get ftp server port
	      String ftpPort = ftpUrl.substring(idx_p1 + 1, idx_slash);
              port = Integer.valueOf(ftpPort).intValue();
              // Get path to follow
	      urlPath = ftpUrl.substring(idx_slash + 1);
            }
            // no path to follow after ftp address
	    else {
              ftpServer = ftpUrl.substring(0, idx_p1);
              String ftpPort = ftpUrl.substring(idx_p1 + 1);
              port = Integer.valueOf(ftpPort).intValue();
              urlPath = "";
            }
          }
          // no server port
	  else {
            int idx_slash = ftpUrl.indexOf("/");
            if (idx_slash > 0) {
              ftpServer = ftpUrl.substring(0, idx_slash);
              urlPath = ftpUrl.substring(idx_slash + 1);
            }
            else {
              ftpServer = ftpUrl.substring(0);
              urlPath = "";
            }
          }
        }
        else {
	  // User 'anonymous'
          user = "anonymous";
            
	  // Get user email as password
	  String config_name = System.getProperty("user.home") + 
	                       File.separator + ".romeo4xmame" + 
			       File.separator + "Romeo.ini";
          File config_file = new File(config_name);
          Config config = new Config(config_file);
          password = config.get("User.mail");

          // no user email: use false one :|
	  if (password.equals(""))
            password = "anonymous@anonymous.org";

          ftpUrl = server.substring(6);
	  int idx_p = ftpUrl.indexOf(":");
	  // ftp server port
          if (idx_p > 0) {
            int idx_slash = ftpUrl.indexOf("/");
            if (idx_slash > 0) {
              ftpServer = ftpUrl.substring(0, idx_p);
              String ftpPort = ftpUrl.substring(idx_p + 1, idx_slash);
              port = Integer.valueOf(ftpPort).intValue();
              urlPath = ftpUrl.substring(idx_slash + 1);
            }
            else {
              ftpServer = ftpUrl.substring(0, idx_p);
              String ftpPort = ftpUrl.substring(idx_p + 1);
              port = Integer.valueOf(ftpPort).intValue();
              urlPath = "";
            }
          }
          else {
            int idx_slash = ftpUrl.indexOf("/");
            if (idx_slash > 0) {
              ftpServer = ftpUrl.substring(0, idx_slash);
              urlPath = ftpUrl.substring(idx_slash + 1);
            }
            else {
              ftpServer = ftpUrl;
              urlPath = "";
            }
          }
        }

        get.removeActionListener(download);

        Thread thread = new Thread() {
          public void run() {
            getFtpFile(ftpServer, port, user, password, urlPath);
          }
        };

        thread.start();
      }
      else {
        JOptionPane.showMessageDialog(null, utils.getString(
                                      "Messagebox.protocol_not_configured"),
                                      utils.getString(
			              "Messagebox.error_title"),
                                        JOptionPane.ERROR_MESSAGE);
      }
    }
  }

  // *******************************************************
  // ********************   Http   *************************
  // *******************************************************

  /**
   * This method downloads a file from a remote server using http protocol.
   */
  protected void getHttpFile() {
    setCursor(Cursor.getPredefinedCursor(Cursor.WAIT_CURSOR));

    try {
      message(statusLabel, utils.getString("Downloader.label_file_size"));

      int size = getHttpFileSize(server, fileName);

      if (size > 0)
        setProgressBarMaximum(size);

      // Print info
      message(statusLabel, utils.getString("Downloader.label_save"));
      message(statusLabel2, fileName + " " + utils.getString(
              "Downloader.from") + " " + server);
      message(downloadInLabel2, destination + fileName);

      //******* Timers
      // Start timer for the animation
      timer.start();
      // Start timer to know elapsed time
      startTime = new GregorianCalendar();
      timer2.start();
      // Start timer to know remaining time
      timer3.start();

      // URL
      URL url = new URL(server + fileName);

      is = url.openStream();
      byte[] bytes = new byte[10240];

      out = new FileOutputStream(destination + fileName);
      int c;
      int total_bytes = 0;
      int received_bytes = 0;

      while((c = is.read(bytes)) != -1) {
        total_bytes += c;
        out.write(bytes, 0, c);

        if (size > 0) {
          setProgressBarValue(total_bytes);
          int proc = (int) Math.round(progressBar.getPercentComplete() * 100);
          setProgressBarString(proc + " %");
        }
        else {
          int kb = total_bytes/1024;
          setProgressBarString(kb + " KB");
        }

        setTransferedKb(total_bytes, size);
      }

      //****** Close all
      is.close();
      is = null;
      out.flush();
      out.close();
      out = null;
      // Stop timers
      timer.stop();
      timer2.stop();
      timer3.stop();
      Toolkit.getDefaultToolkit().beep();
      get.addActionListener(download);
      close.setText(utils.getString("Downloader.button_close"));

      Runnable runner = new Runnable() {
        public void run() {
          setCursor(Cursor.getPredefinedCursor(Cursor.DEFAULT_CURSOR));
        }
      };
      SwingUtilities.invokeLater(runner);
    }
    catch (java.net.MalformedURLException exc) {
      System.err.println(exc.getMessage());
    }
    catch (IOException ioe) {
      System.err.println(ioe.getMessage());
    }
  }

  /**
   * This method returns the file size from the http server.
   *
   * @param server   The http server
   * @param fileName The file name
   * @return         The file size
   * @throws         IOException
   */
  public static int getHttpFileSize(String server,
                                    String fileName) throws IOException {
    int c = -1;

    URL url = new URL(server + fileName);

    HttpURLConnection connection = (HttpURLConnection)url.openConnection();
    
    // Verify if file exists on remote server:
    // response code has not to be equal to 404
    // (FILE_NOT_FOUND)
    int code = connection.getResponseCode();

    if (code != 404) {
      c = connection.getContentLength();

      if (c > 0)
        c = c;
    }
    else {
      JOptionPane.showMessageDialog(null,
	                            "Uh oh, could not find " + fileName +
				    " on remote server!",
                                    "Error",
                                    JOptionPane.ERROR_MESSAGE);
      frame.setVisible(false);
      final JFrame frame = null;
    }
    
    return c;
  }

  // *******************************************************
  // ********************   Ftp    *************************
  // *******************************************************

  /**
   * This method downloads a file from a remote ftp server.
   *
   * @param ftpServer The ftp server
   * @param port      The server port to connect to
   * @param user      The user name
   * @param password  The password
   * @param urlPath   The file URL
   */
  protected void getFtpFile(String ftpServer, int port, String user,
                            String password, String urlPath) {
    // Change cursor while Downloader retrieves info
    setCursor(Cursor.getPredefinedCursor(Cursor.WAIT_CURSOR));

    try {
      message(statusLabel2, utils.getString("Downloader.label_connect") + 
              " " + ftpServer);

      // Did the user define a port?
      if (port > 0)
        client = new FtpClient(ftpServer, port);
      else
        client = new FtpClient(ftpServer);

      // Login
      client.login(user, password);

      message(statusLabel2, utils.getString("Downloader.label_login"));
      message(statusLabel2, client.welcomeMsg);

      // Go to specified dir
      client.cd(urlPath);
      message(statusLabel2, "Directory: " + urlPath);

      client.binary();

      message(statusLabel, utils.getString("Downloader.label_save"));
      message(statusLabel2, fileName + " " + utils.getString(
              "Downloader.from") + " " + ftpServer);
      message(downloadInLabel2, destination + fileName);

      // Start the animation.
      timer.start();
      // Get elapsed time
      startTime = new GregorianCalendar();
      timer2.start();
      // Start timer to know time left
      timer3.start();

      byte[] buffer = new byte[10240];

      try {
	int size = getFtpFileSize(client, fileName);

        if (size > 0) {
          //message("File " + fileName + ": " + size + " bytes");
          setProgressBarMaximum(size);
        }
        else {}

        out = new FileOutputStream(destination + fileName);
        is = client.get(fileName);
        int counter = 0;

        while(true) {
          int bytes = is.read(buffer);
          if (bytes < 0)
            break;

          out.write(buffer, 0, bytes);
          counter += bytes;
          if (size > 0) {
            setProgressBarValue(counter);
            int proc = (int) Math.round(progressBar.getPercentComplete() * 100);
            setProgressBarString(proc + " %");
          }
          else {
            int kb = counter/1024;
            setProgressBarString(kb + " KB");
          }

          setTransferedKb(counter, size);
        }

        //****** Close all
	out.flush();
        out.close();
	out = null;
        is.close();
	is = null;
        // Stop timers
	timer.stop();
        timer2.stop();
	timer3.stop();
        Toolkit.getDefaultToolkit().beep();
        disconnect();
	get.addActionListener(download);
	close.setText(utils.getString("Downloader.button_close"));
      }
      catch (Exception ex) {
        message(statusLabel2, ex.toString());
        disconnect();
      }
    }
    catch (Exception e) {
      System.out.println(e.getMessage());
      disconnect();
    }
  }

  /**
   * This methods disconnects client from the ftp server.
   */
  protected void disconnect() {
    if (client != null) {
      try {
        client.closeServer();
      }
      catch (IOException ex) {}

      client = null;
    }
    Runnable runner = new Runnable() {
      public void run() {
        setCursor(Cursor.getPredefinedCursor(Cursor.DEFAULT_CURSOR));
      }
    };
    SwingUtilities.invokeLater(runner);
  }

  /**
   * This method returns the file size from the ftp server
   * Probably not working. I have not tested it yet :|
   *
   * @param client   The FtpClient
   * @param fileName The file name
   * @return         The file size
   * @throws         IOException
   */
  public static int getFtpFileSize(FtpClient client,
                                   String fileName) throws IOException {
    TelnetInputStream lst = client.list();
    String str = "";
    fileName = fileName.toLowerCase();
    while(true) {
      int c = lst.read();
      char ch = (char) c;
      if (c < 0 || ch == '\n') {
        str = str.toLowerCase();
        if (str.indexOf(fileName) >= 0) {
          StringTokenizer tk = new StringTokenizer(str);
          int index = 0;
          while(tk.hasMoreTokens()) {
            String token = tk.nextToken();
            if (index == 4)
              try {
                return Integer.parseInt(token);
              }
              catch (NumberFormatException ex) {
                return -1;
              }
            index++;
          }
        }
        str = "";
      }
      if (c <= 0)
        break;
      str += ch;
    }
    return -1;
  }

  // *******************************************************
  // ****************** Utility Methods ********************
  // *******************************************************
  /*
  public float getTransferRate() {
    if (startTime != -1) {
      long currentTime = System.currentTimeMillis();

      return bytesWritten / (float) (currentTime - startTime);
    }

    else return -1.0f;
  }
  */
  /**
   * Messages from the ftp server.
   *
   * @param label The label where to set message in
   * @param str   The message
   */
  protected void message(final JLabel label, final String str) {
    if (str != null) {
      Runnable runner = new Runnable() {
        public void run() {
          label.setText(str);
        }
      };
      SwingUtilities.invokeLater(runner);
    }
  }

  /**
   * This method sets progress bar value.
   *
   * @param value The value to set
   */
  protected void setProgressBarValue(final int value) {
    Runnable runner = new Runnable() {
      public void run() {
        progressBar.setValue(value);
      }
    };
    SwingUtilities.invokeLater(runner);
  }

  /**
   * This method sets progress bar maximum value.
   *
   * @param value The maximum value to set
   */
  protected void setProgressBarMaximum(final int value) {
    Runnable runner = new Runnable() {
      public void run() {
        progressBar.setMaximum(value);
      }
    };
    SwingUtilities.invokeLater(runner);
  }

  /**
   * This method sets progress bar string.
   *
   * @param string The string to set
   */
  protected void setProgressBarString(final String string) {
    Runnable runner = new Runnable() {
      public void run() {
        progressBar.setString(string);
      }
    };
    SwingUtilities.invokeLater(runner);
  }

  /**
   * This method sets transfered kb string in a specific label.
   *
   * @param value The transfered kb
   * @param size  The file size
   */
  protected void setTransferedKb(final int value, final int size) {
    Runnable runner = new Runnable() {
      public void run() {
        if (size > 0) {
          transferedKbLabel2.setText((value/1024) + " KB " +
                       utils.getString("Downloader.label_kb_of") +
                       " " + (size/1024) + " KB");
        }
	else {
	  transferedKbLabel2.setText((value/1024) + " KB");
	}
      }
    };
    SwingUtilities.invokeLater(runner);
  }
}  // That' s all, folks :)
